/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.internet.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="PRAESENTATIONSEXPORT.UK",
     query="SELECT o FROM Praesentationsexport o WHERE "

                         + "o"
                +".praesentationsexportart"
              +" = ?1"

             +" AND "         + "o"
                +".praesentationsexportausloeser"
              +" = ?2"

             +" AND "         + "o"
                +".stimmabgabeart"
              +" = ?3"

             +" AND "         + "o"
                +".ergebnis"
                +".ergebnisart"
              +" = ?4"

             +" AND "         + "o"
                +".ergebnis"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?6"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?8"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?9"

             +" AND "         + "o"
                +".ergebnis"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?10"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="PRAESENTATIONSEXPORT.ByErgebnisAndPraesentationsexportart",
     query="DELETE FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PRAESENTATIONSEXPORT.ByErgebnis",
     query="SELECT p FROM Praesentationsexport p WHERE p.ergebnis=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PRAESENTATIONSEXPORT.CountErgebnisAndArten",
     query="SELECT COUNT(p) FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart=?2 AND p.stimmabgabeart = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PRAESENTATIONSEXPORT.ErgebnisAndArtAndAusloeserAndStimmabgabeart",
     query="SELECT p FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart = ?2 AND p.praesentationsexportausloeser=?3 AND p.stimmabgabeart = ?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PRAESENTATIONSEXPORT.ErgebnisAndArten",
     query="SELECT p FROM Praesentationsexport p WHERE p.ergebnis=?1 AND p.praesentationsexportart=?2 AND p.stimmabgabeart = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "PRAESENTATIONSEXPORT")
// @javax.persistence.IdClass(PraesentationsexportPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Praesentationsexport
implements PraesentationsexportBase
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Praesentationsexport() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Praesentationsexport(Praesentationsexport original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "praesentationsexport_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Praesentationsexport")
    @javax.persistence.TableGenerator(name = "Praesentationsexport", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Praesentationsexport", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient PraesentationsexportPK pkCache;

  @Override
  public PraesentationsexportPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new PraesentationsexportPK(getId());
    }

    return pkCache;
  }

  public static <E extends Praesentationsexport> java.util.Map<PraesentationsexportPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<PraesentationsexportPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Praesentationsexport> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedExportsequenznummer = false;
          hasChangedLetzteEingangssequenznummer = false;
          hasChangedPraesentationsexportart = false;
          hasChangedPraesentationsexportausloeser = false;
          hasChangedStimmabgabeart = false;
  
      hasChangedDatei = false;
        hasChangedErgebnis = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "EXPORTSEQUENZNUMMER", nullable = PraesentationsexportConstants.EXPORTSEQUENZNUMMER_NULLABLE, precision=PraesentationsexportConstants.EXPORTSEQUENZNUMMER_PRECISION, scale=PraesentationsexportConstants.EXPORTSEQUENZNUMMER_SCALE)
            
  protected java.lang.Long exportsequenznummer =  Long.valueOf("0");

  @javax.persistence.Transient
  protected boolean hasChangedExportsequenznummer = false;

  public boolean hasChangedExportsequenznummer(){
    return hasChangedExportsequenznummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertExportsequenznummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenExportsequenznummer;
  
  /**
   * 
   *
   * getter for PRAESENTATIONSEXPORT.EXPORTSEQUENZNUMMER
   */
    @Override   public  java.lang.Long getExportsequenznummer() {
        return exportsequenznummer;
      }

  /**
   * 
   *
   * setter for PRAESENTATIONSEXPORT.EXPORTSEQUENZNUMMER
   *
   * @param exportsequenznummer
   */
  @Override   public void setExportsequenznummer( java.lang.Long exportsequenznummer) {

       resetTkCache();
                  java.lang.Long exportsequenznummerInternal = exportsequenznummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.exportsequenznummer
      , exportsequenznummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedExportsequenznummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("exportsequenznummer");
      }


             if (!isSeitLadenVeraendertExportsequenznummer) {
          isSeitLadenVeraendertExportsequenznummer = thisAttributChanged;
         if (isSeitLadenVeraendertExportsequenznummer){
           wertNachLadenExportsequenznummer=this.exportsequenznummer;
         }
       }
      

       this.exportsequenznummer = exportsequenznummerInternal;

         }

        
      @javax.persistence.Column(name = "LETZTE_EINGANGSSEQUENZNUMMER", nullable = PraesentationsexportConstants.LETZTE_EINGANGSSEQUENZNUMMER_NULLABLE, precision=PraesentationsexportConstants.LETZTE_EINGANGSSEQUENZNUMMER_PRECISION, scale=PraesentationsexportConstants.LETZTE_EINGANGSSEQUENZNUMMER_SCALE)
            
  protected java.lang.Long letzteEingangssequenznummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLetzteEingangssequenznummer = false;

  public boolean hasChangedLetzteEingangssequenznummer(){
    return hasChangedLetzteEingangssequenznummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLetzteEingangssequenznummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenLetzteEingangssequenznummer;
  
  /**
   * 
   *
   * getter for PRAESENTATIONSEXPORT.LETZTE_EINGANGSSEQUENZNUMMER
   */
    @Override   public  java.lang.Long getLetzteEingangssequenznummer() {
        return letzteEingangssequenznummer;
      }

  /**
   * 
   *
   * setter for PRAESENTATIONSEXPORT.LETZTE_EINGANGSSEQUENZNUMMER
   *
   * @param letzteEingangssequenznummer
   */
  @Override   public void setLetzteEingangssequenznummer( java.lang.Long letzteEingangssequenznummer) {

       resetTkCache();
                  java.lang.Long letzteEingangssequenznummerInternal = letzteEingangssequenznummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.letzteEingangssequenznummer
      , letzteEingangssequenznummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLetzteEingangssequenznummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("letzteEingangssequenznummer");
      }


             if (!isSeitLadenVeraendertLetzteEingangssequenznummer) {
          isSeitLadenVeraendertLetzteEingangssequenznummer = thisAttributChanged;
         if (isSeitLadenVeraendertLetzteEingangssequenznummer){
           wertNachLadenLetzteEingangssequenznummer=this.letzteEingangssequenznummer;
         }
       }
      

       this.letzteEingangssequenznummer = letzteEingangssequenznummerInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PRAESENTATIONSEXPORTART", nullable = PraesentationsexportConstants.PRAESENTATIONSEXPORTART_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPraesentationsexportart = false;

  public boolean hasChangedPraesentationsexportart(){
    return hasChangedPraesentationsexportart;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPraesentationsexportart = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.ergebnis.entity.Praesentationsexportart wertNachLadenPraesentationsexportart;
  
  /**
   * 
   *
   * getter for PRAESENTATIONSEXPORT.PRAESENTATIONSEXPORTART
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.Praesentationsexportart getPraesentationsexportart() {
        return praesentationsexportart;
      }

  /**
   * 
   *
   * setter for PRAESENTATIONSEXPORT.PRAESENTATIONSEXPORTART
   *
   * @param praesentationsexportart
   */
  @Override   public void setPraesentationsexportart( de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportart) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.Praesentationsexportart praesentationsexportartInternal = praesentationsexportart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.praesentationsexportart
      , praesentationsexportartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPraesentationsexportart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("praesentationsexportart");
      }


             if (!isSeitLadenVeraendertPraesentationsexportart) {
          isSeitLadenVeraendertPraesentationsexportart = thisAttributChanged;
         if (isSeitLadenVeraendertPraesentationsexportart){
           wertNachLadenPraesentationsexportart=this.praesentationsexportart;
         }
       }
      

       this.praesentationsexportart = praesentationsexportartInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PRAESENTATIONSEXPORTAUSLOESER", nullable = PraesentationsexportConstants.PRAESENTATIONSEXPORTAUSLOESER_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeser =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPraesentationsexportausloeser = false;

  public boolean hasChangedPraesentationsexportausloeser(){
    return hasChangedPraesentationsexportausloeser;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPraesentationsexportausloeser = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser wertNachLadenPraesentationsexportausloeser;
  
  /**
   * 
   *
   * getter for PRAESENTATIONSEXPORT.PRAESENTATIONSEXPORTAUSLOESER
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser getPraesentationsexportausloeser() {
        return praesentationsexportausloeser;
      }

  /**
   * 
   *
   * setter for PRAESENTATIONSEXPORT.PRAESENTATIONSEXPORTAUSLOESER
   *
   * @param praesentationsexportausloeser
   */
  @Override   public void setPraesentationsexportausloeser( de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeser) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser praesentationsexportausloeserInternal = praesentationsexportausloeser;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.praesentationsexportausloeser
      , praesentationsexportausloeserInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPraesentationsexportausloeser |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("praesentationsexportausloeser");
      }


             if (!isSeitLadenVeraendertPraesentationsexportausloeser) {
          isSeitLadenVeraendertPraesentationsexportausloeser = thisAttributChanged;
         if (isSeitLadenVeraendertPraesentationsexportausloeser){
           wertNachLadenPraesentationsexportausloeser=this.praesentationsexportausloeser;
         }
       }
      

       this.praesentationsexportausloeser = praesentationsexportausloeserInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STIMMABGABEART", nullable = PraesentationsexportConstants.STIMMABGABEART_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart =  de.ivu.elect.business.ergebnis.entity.Stimmabgabeart.GESAMT;

  @javax.persistence.Transient
  protected boolean hasChangedStimmabgabeart = false;

  public boolean hasChangedStimmabgabeart(){
    return hasChangedStimmabgabeart;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStimmabgabeart = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.ergebnis.entity.Stimmabgabeart wertNachLadenStimmabgabeart;
  
  /**
   * 
   *
   * getter for PRAESENTATIONSEXPORT.STIMMABGABEART
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.Stimmabgabeart getStimmabgabeart() {
        return stimmabgabeart;
      }

  /**
   * 
   *
   * setter for PRAESENTATIONSEXPORT.STIMMABGABEART
   *
   * @param stimmabgabeart
   */
  @Override   public void setStimmabgabeart( de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeart) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.Stimmabgabeart stimmabgabeartInternal = stimmabgabeart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.stimmabgabeart
      , stimmabgabeartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStimmabgabeart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("stimmabgabeart");
      }


             if (!isSeitLadenVeraendertStimmabgabeart) {
          isSeitLadenVeraendertStimmabgabeart = thisAttributChanged;
         if (isSeitLadenVeraendertStimmabgabeart){
           wertNachLadenStimmabgabeart=this.stimmabgabeart;
         }
       }
      

       this.stimmabgabeart = stimmabgabeartInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Datei
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "DATEI_ID", referencedColumnName="DATEI_ID"))
  protected de.ivu.elect.business.datei.entity.Datei datei;

  /**
   * 
   */
  @Override
  public void setDatei( de.ivu.elect.business.datei.entity.Datei datei){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datei
    , datei);

    attributeChanged |= thisAttributChanged;

    hasChangedDatei |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("datei");
    }

    this.datei = datei;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.datei.entity.Datei getDatei(){
    return this.datei;
  }

  @javax.persistence.Transient
  protected boolean hasChangedDatei = false;

  public boolean hasChangedDatei(){
    return hasChangedDatei;
  }

  /**
   * Beziehung (unidirektional) zu Ergebnis
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNIS_ID", referencedColumnName="ERGEBNIS_ID"))
  protected de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis;

  /**
   * 
   */
  @Override
  public void setErgebnis( de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnis
    , ergebnis);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebnis |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebnis");
    }

    this.ergebnis = ergebnis;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.ergebnis.entity.Ergebnis getErgebnis(){
    return this.ergebnis;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebnis = false;

  public boolean hasChangedErgebnis(){
    return hasChangedErgebnis;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Praesentationsexport:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Praesentationsexport other){
                             other.exportsequenznummer = this.exportsequenznummer;
                                other.letzteEingangssequenznummer = this.letzteEingangssequenznummer;
                                other.praesentationsexportart = this.praesentationsexportart;
                                other.praesentationsexportausloeser = this.praesentationsexportausloeser;
                                other.stimmabgabeart = this.stimmabgabeart;
           
  other.setDatei(this.getDatei());
  other.setErgebnis(this.getErgebnis());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Praesentationsexport.class)){
        copyEntityAttributesUsingSetter((Praesentationsexport) other.castTo(Praesentationsexport.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Praesentationsexport: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Praesentationsexport other){
               other.setExportsequenznummer(this.exportsequenznummer);
                  other.setLetzteEingangssequenznummer(this.letzteEingangssequenznummer);
                  other.setPraesentationsexportart(this.praesentationsexportart);
                  other.setPraesentationsexportausloeser(this.praesentationsexportausloeser);
                  other.setStimmabgabeart(this.stimmabgabeart);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Praesentationsexport other){
                       if (hasChangedExportsequenznummer) {
        other.setExportsequenznummer(this.exportsequenznummer);
      }
                             if (hasChangedLetzteEingangssequenznummer) {
        other.setLetzteEingangssequenznummer(this.letzteEingangssequenznummer);
      }
                             if (hasChangedPraesentationsexportart) {
        other.setPraesentationsexportart(this.praesentationsexportart);
      }
                             if (hasChangedPraesentationsexportausloeser) {
        other.setPraesentationsexportausloeser(this.praesentationsexportausloeser);
      }
                             if (hasChangedStimmabgabeart) {
        other.setStimmabgabeart(this.stimmabgabeart);
      }
             }





    @javax.persistence.Transient
    private transient PraesentationsexportTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public PraesentationsexportTK getPraesentationsexportTK(){
    if (tkCache==null) {
    tkCache = new PraesentationsexportTK(

getPraesentationsexportart()
, getPraesentationsexportausloeser()
, getStimmabgabeart()
,   (getErgebnis() == null) ? null : getErgebnis().getErgebnisTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getPraesentationsexportTK();
    }

  @Override
  public PraesentationsexportUK getUk(){
    return getPraesentationsexportUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Praesentationsexport.class;
  }

public PraesentationsexportUK getPraesentationsexportUK(){

   return  new PraesentationsexportUK(

getPraesentationsexportart()
, getPraesentationsexportausloeser()
, getStimmabgabeart()
,     getErgebnis()==null?null:getErgebnis().getErgebnisUK()


  );
}

  @javax.persistence.Transient
  private transient PraesentationsexportProperties properties;

  public PraesentationsexportProperties getProperties(){
    if (properties == null) {
      properties = new PraesentationsexportProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public PraesentationsexportProperties getPraesentationsexportProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return PraesentationsexportConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(PraesentationsexportConstants.MESSAGE_KEY_EXPORTSEQUENZNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PraesentationsexportConstants.MESSAGE_KEY_EXPORTSEQUENZNUMMER_EINZAHL);

        exportsequenznummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(PraesentationsexportConstants.MESSAGE_KEY_LETZTE_EINGANGSSEQUENZNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PraesentationsexportConstants.MESSAGE_KEY_LETZTE_EINGANGSSEQUENZNUMMER_EINZAHL);

        letzteEingangssequenznummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTART_EINZAHL);

        praesentationsexportart =
     (de.ivu.elect.business.ergebnis.entity.Praesentationsexportart) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTAUSLOESER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTAUSLOESER_EINZAHL);

        praesentationsexportausloeser =
     (de.ivu.elect.business.ergebnis.entity.Praesentationsexportausloeser) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(PraesentationsexportConstants.MESSAGE_KEY_STIMMABGABEART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PraesentationsexportConstants.MESSAGE_KEY_STIMMABGABEART_EINZAHL);

        stimmabgabeart =
     (de.ivu.elect.business.ergebnis.entity.Stimmabgabeart) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertExportsequenznummer) {
      result.put(PraesentationsexportConstants.MESSAGE_KEY_EXPORTSEQUENZNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenExportsequenznummer , exportsequenznummer));
    }
                            if (isSeitLadenVeraendertLetzteEingangssequenznummer) {
      result.put(PraesentationsexportConstants.MESSAGE_KEY_LETZTE_EINGANGSSEQUENZNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenLetzteEingangssequenznummer , letzteEingangssequenznummer));
    }
                            if (isSeitLadenVeraendertPraesentationsexportart) {
      result.put(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenPraesentationsexportart , praesentationsexportart));
    }
                            if (isSeitLadenVeraendertPraesentationsexportausloeser) {
      result.put(PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTAUSLOESER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenPraesentationsexportausloeser , praesentationsexportausloeser));
    }
                            if (isSeitLadenVeraendertStimmabgabeart) {
      result.put(PraesentationsexportConstants.MESSAGE_KEY_STIMMABGABEART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStimmabgabeart , stimmabgabeart));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertExportsequenznummer = false;
      wertNachLadenExportsequenznummer = null;
                          isSeitLadenVeraendertLetzteEingangssequenznummer = false;
      wertNachLadenLetzteEingangssequenznummer = null;
                          isSeitLadenVeraendertPraesentationsexportart = false;
      wertNachLadenPraesentationsexportart = null;
                          isSeitLadenVeraendertPraesentationsexportausloeser = false;
      wertNachLadenPraesentationsexportausloeser = null;
                          isSeitLadenVeraendertStimmabgabeart = false;
      wertNachLadenStimmabgabeart = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "PRAESENTATIONSEXPORT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Praesentationsexport";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(exportsequenznummer, this, PraesentationsexportConstants.MESSAGE_KEY_EXPORTSEQUENZNUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(PraesentationsexportConstants.EXPORTSEQUENZNUMMER_MAX_VALUE, PraesentationsexportConstants.EXPORTSEQUENZNUMMER_MIN_VALUE, exportsequenznummer, this, PraesentationsexportConstants.MESSAGE_KEY_EXPORTSEQUENZNUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(letzteEingangssequenznummer, this, PraesentationsexportConstants.MESSAGE_KEY_LETZTE_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(PraesentationsexportConstants.LETZTE_EINGANGSSEQUENZNUMMER_MAX_VALUE, PraesentationsexportConstants.LETZTE_EINGANGSSEQUENZNUMMER_MIN_VALUE, letzteEingangssequenznummer, this, PraesentationsexportConstants.MESSAGE_KEY_LETZTE_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(praesentationsexportart, this, PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(praesentationsexportausloeser, this, PraesentationsexportConstants.MESSAGE_KEY_PRAESENTATIONSEXPORTAUSLOESER_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(stimmabgabeart, this, PraesentationsexportConstants.MESSAGE_KEY_STIMMABGABEART_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
